package cz.muni.fi.pv168.graves;

import java.util.List;

/**
 * This class represents a manager for handling graves and bodies.
 *
 * @author Eva Kucirkova (eva.k@mail.muni.cz)
 */
public interface CemeteryManager {

    /**
     * Get all graves.
     * @return list of all graves (empty if none present)
     */
    public List<Grave> getAllGraves();

    /**
     * Gets grave by its id.
     * @param id id
     * @return grave, null if not found
     */
    public Grave getGraveById(Long id);

    /**
     * Adds grave to the cemetery. While adding a grave
     * its ID must be null.
     *
     * @param grave grave to add
     * @throws IllegalArgumentException when argument is null,
     * grave has negative capacity, or grave ID is already set
     */
    public void addGrave(Grave grave);

    public void deleteGrave(Grave grave);

    public void updateGrave(Grave grave);
}
